/*
 *	@(#)cmos.h	1.2 88/03/19 
 *
 *	Copyright (C) Microsoft Corporation, 1986
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 *
 *	Copyright (C) The Santa Cruz Operation, 1985, 1986
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation and should be treated as Confidential.
 *
 *	Copyrighted as an unpublished work.
 * 	(c) Copyright 1986 INTERACTIVE Systems Corporation
 *	All rights reserved.
 */
/* 
 *	Include file for: 
 *		MOTOROLA MC146818 RealTime Clock/RAM System Information
 *		Console video related defines.
 *
 */

/************** MOTOROLA 146818 hardware defines. ********************/

/* Ports for interacting with chip at */

#define CMOSADDR	0x70 	/* Use to select RAM address */
#define CMOSDATA	0x71	/* R/W data */

/* Number of cmos bytes */

#define CMOSSIZE	0x40	/* 64 addressable bytes in chip */

/* Addresses of interest */

#define CMOSDIAG	0x0e	/* Diagnostic Status */
#define	CMOSSSB		0x0f	/* Shutdown status byte ram address */
#define CMOSFDT		0x10	/* Floppy Disk Type */
#define CMOSHDT		0x12	/* Hard Disk Type; bits 7-4 are 1st drive */
#define CMOSEQP		0x14	/* Diskette, Video, and CoProcessor info */
#define	CMOSBL		0x15	/* Base mem size low byte ram address */
#define	CMOSBH		0x16	/* Base mem size high byte ram address */
#define	CMOSEL		0x17	/* Expansion mem size low byte ram address */
#define	CMOSEH		0x18	/* Expansion mem size high byte ram address */
#define	CMOSDCEB	0x19	/* Drive C Extended byte ram address */
#define	CMOSDDEB	0x1a	/* Drive D Extended byte ram address */
#define CMOSADF		0x2d	/* Additional flags - Compaq VDU info */
#define	CMOSCKLOW	0x2e	/* Checksum low byte ram address */
#define	CMOSCKHIGH	0x2f	/* Checksum high byte ram address */
#define	CMOSEL2		0x30	/* Expansion mem size low byte ram address */
#define	CMOSEH2		0x31	/* Expansion mem size high byte ram address */
#define	CMOSDCB		0x32	/* Date century byte ram address */
#define	CMOSIF		0x33	/* Information flag ram address */

/* Shifts of interest */

#define VID_SHFT	4	/* Shift display type bits into 0-3 */

/* masks of interest */
#define CMPQVDU		0x04	/* Compaq VDU bit */
#define CMPQDMM		0x01	/* Compaq Dual Mode Monitor bit */
